'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function ImagePreload(Component, imagePreloadPropNames) {
  var ImagePreloadComponent = (function (_React$Component) {
    _inherits(ImagePreloadComponent, _React$Component);

    function ImagePreloadComponent(props) {
      var _this = this;

      _classCallCheck(this, ImagePreloadComponent);

      _get(Object.getPrototypeOf(ImagePreloadComponent.prototype), 'constructor', this).call(this, props);
      this.images = {};
      var state = {};

      imagePreloadPropNames.filter(function (imageName) {
        return _this.props[imageName];
      }).forEach(function (imageName) {
        _this.preloadImage(imageName, _this.props[imageName]);
        state[imageName + 'Status'] = ImagePreload.STATUS_PENDING;
      });

      this.state = state;
    }

    _createClass(ImagePreloadComponent, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var _this2 = this;

        var nextState = {};

        imagePreloadPropNames.filter(function (imageName) {
          return _this2.props[imageName] !== nextProps[imageName];
        }).forEach(function (imageName) {
          if (!nextProps[imageName]) {
            _this2.removeImageFromCache(imageName);
            nextState[imageName + 'Status'] = null;
            return;
          }

          _this2.preloadImage(imageName, _this2.props[imageName]);
          nextState[imageName + 'Status'] = ImagePreload.STATUS_PENDING;
        });

        if (!isEmpty(nextState)) this.setState(nextState);
      }
    }, {
      key: 'onImageLoad',
      value: function onImageLoad(imageName) {
        this.setState(_defineProperty({}, imageName + 'Status', ImagePreload.STATUS_LOADED));
      }
    }, {
      key: 'onImageError',
      value: function onImageError(imageName) {
        this.setState(_defineProperty({}, imageName + 'Status', ImagePreload.STATUS_FAILED));
      }
    }, {
      key: 'removeImageFromCache',
      value: function removeImageFromCache(imageName) {
        var image = this.images[imageName];

        if (!image) return;

        image.onload = null;
        image.onerror = null;
        delete this.images[imageName];
      }
    }, {
      key: 'preloadImage',
      value: function preloadImage(imageName, imageSrc) {
        var _this3 = this;

        var image = new Image();

        image.onload = function () {
          return _this3.onImageLoad(imageName);
        };
        image.onerror = function () {
          return _this3.onImageError(imageName);
        };
        image.src = imageSrc;

        this.images[imageName] = image;
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(Component, _extends({}, this.props, this.state));
      }
    }]);

    return ImagePreloadComponent;
  })(_react2['default'].Component);

  return ImagePreloadComponent;
}

ImagePreload.STATUS_PENDING = 'PENDING';
ImagePreload.STATUS_LOADED = 'LOADED';
ImagePreload.STATUS_FAILED = 'FAILED';

function isEmpty(object) {
  return !object || Object.keys(object).length === 0;
}

exports['default'] = ImagePreload;
module.exports = exports['default'];